// background.js
console.log('我是后台js...');
//
function util_isnumber(val){
    var regPos = /^[0-9]+.?[0-9]*/; //判断是否是数字。
    if(regPos.test(val) ){
        return true;
    }else{
        return false;
    }
}

function util_get_date(timestamp=0){
    let date = new Date(timestamp); // 创建一个日期对象
    return date.getFullYear()+'-'+(date.getMonth() + 1)+'-'+date.getDate();
}

function util_get_now_date(){
    let date = new Date(Date.now()); // 创建一个日期对象
    return date.getFullYear()+'-'+(date.getMonth() + 1)+'-'+date.getDate();
}

function util_get_asin(url = ''){
    let url_arr = url.split('dp/');
    if(url_arr.length>=2){
        let url_dp_str = url_arr[1];
        let url_dp_arr = url_dp_str.split('/');
        let dp =  url_dp_arr[0];
        if(dp.length>=6){
            return dp;
        }
    }
    return '';
}

/**
 * 字典数组排序，只针对纯英文、数字或纯中文的排序
 * @param: dictArray 需要排序的字典数组
 * @param: sortKey  需要进行排序的键
 * @param: sortType asc升序(默认)  desc 降序
 **/
function util_dictArraySorting(dictArray,sortKey,sortType="asc"){
    if (sortType == 'asc'){
      dictArray.sort(function (dictA, dictB){
        return escape(dictA[sortKey]).indexOf("%u") < 0? dictA[sortKey] - dictB[sortKey]:dictA[sortKey].localeCompare(dictB[sortKey])
      })
    }
    if (sortType == 'desc'){
      dictArray.sort(function (dictA, dictB){
          console.log(dictA);
        return escape(dictA[sortKey]).indexOf("%u") < 0? dictB[sortKey] - dictA[sortKey]:dictB[sortKey].localeCompare(dictA[sortKey])
      })
    }
    return dictArray
}

function extractEmails (text) {
    text = text.replaceAll('<b>', '').replaceAll('</b>', '');
    return text.match(/([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)/gi);
}

function selectPhoneNumber(str) {
    const phoneReg = /(1[0-9]{10})|([0-9]{3,4})?[0-9]{7,12}/g;//匹配手机号或者固话
    const num = str.replace(/\s|[(]|[)]|[（]|[）]|[-]*/g, '');//去除字符串中所有空格、小括号和横杠
    const phone_arr = num.match(phoneReg);//识别手机号或者固话（在字符串内检索指定的值，或找到一个或多个正则表达式的匹配）
    let phone = '';
    if(phone_arr && phone_arr.length > 0){
        for(let i=0;i<phone_arr.length;i++){
            phone = phone_arr[i];
            if(phone.indexOf('86') != -1 || phone.indexOf('0755') != -1){
                break;
            }
        }
    }
    return phone;
}

function get_phone(str=''){
    var $html = $(str);
    let phone = '';
    $html.find('a').each(function (){
        let _ahref = $(this).attr('href');
        if(_ahref && (_ahref.indexOf('tel') != -1 || _ahref.indexOf('phone') != -1) &&
            _ahref.indexOf('www') ==-1 && _ahref.indexOf('hotel') ==-1 &&
            _ahref.indexOf('Intellectual') ==-1 &&
            _ahref.indexOf('Patel') ==-1
        ){
            phone = $(this).text();
        }
    });
    //td中的phone
    if(phone == '' || !phone){
        $html.find('table td').each(function (){
                let _td_val = $(this).text();
                if((_td_val.indexOf('+86')!=-1 ||
                    _td_val.indexOf('Hotline') != -1 ||
                    _td_val.indexOf('fax') != -1 ||
                    _td_val.indexOf('mobile') != -1 ||
                    _td_val.indexOf('0086')!=-1 ||
                    _td_val.indexOf('86-0755')!=-1 ||
                    _td_val.indexOf('0755')!=-1 ||
                    _td_val.indexOf('tel')!=-1 ||
                    _td_val.indexOf('whatsapp') != -1 ||
                    _td_val.indexOf('phone') != -1 ||
                    _td_val.indexOf('专线')!=-1) && (_td_val.indexOf('hotel') ==-1 &&
                    _td_val.indexOf('Intellectual') ==-1 &&
                    _td_val.indexOf('Patel') ==-1)
                ){
                    phone = _td_val;
                }
        });
    }
    //
    if(phone == '' || !phone){
       $html.find('p').each(function (){
           let _p_text = $(this).text();
           if((_p_text.indexOf('tel') != -1 ||
               _p_text.indexOf('Hotline') != -1 ||
               _p_text.indexOf('fax') != -1 ||
               _p_text.indexOf('mobile') != -1 ||
               _p_text.indexOf('+86')!=-1 ||
               _p_text.indexOf('0086')!=-1 ||
               _p_text.indexOf('86-0755')!=-1 ||
               _p_text.indexOf('0755')!=-1 ||
               _p_text.indexOf('whatsapp') != -1 ||
               _p_text.indexOf('phone') != -1 ||
               _p_text.indexOf('专线')!=-1) && (_p_text.indexOf('hotel') ==-1 &&
                    _p_text.indexOf('Intellectual') ==-1 &&
                    _p_text.indexOf('Patel') ==-1)
           ){
               phone = _p_text;
           }
       });
    }
    //
    if(phone == '' || !phone){
       $html.find('li').each(function (){
           let _div_text = $(this).text();
           if((_div_text.indexOf('tel') != -1 ||
               _div_text.indexOf('Hotline') != -1 ||
               _div_text.indexOf('fax') != -1 ||
               _div_text.indexOf('mobile') != -1 ||
               _div_text.indexOf('+86') != -1 ||
               _div_text.indexOf('0086') != -1 ||
               _div_text.indexOf('86-0755') != -1 ||
               _div_text.indexOf('0755')!=-1 ||
               _div_text.indexOf('whatsapp') != -1 ||
               _div_text.indexOf('phone') != -1 ||
               _div_text.indexOf('专线')!=-1) && (_div_text.indexOf('hotel') ==-1 &&
                    _div_text.indexOf('Intellectual') ==-1 &&
                    _div_text.indexOf('Patel') ==-1)
           ){
               phone = _div_text;
           }
       });
    }
    //
    if(phone == '' || !phone){
       $html.find('span').each(function (){
           let _div_text = $(this).text();
           if((_div_text.indexOf('tel') != -1 ||
               _div_text.indexOf('Hotline') != -1 ||
               _div_text.indexOf('fax') != -1 ||
               _div_text.indexOf('mobile') != -1 ||
               _div_text.indexOf('+86') != -1 ||
               _div_text.indexOf('0086') != -1 ||
               _div_text.indexOf('86-0755') != -1 ||
               _div_text.indexOf('0755')!=-1 ||
               _div_text.indexOf('whatsapp') != -1 ||
               _div_text.indexOf('phone') != -1 ||
               _div_text.indexOf('专线')!=-1) && (_div_text.indexOf('hotel') ==-1 &&
                    _div_text.indexOf('Intellectual') ==-1 &&
                    _div_text.indexOf('Patel') ==-1)
           ){
               phone = _div_text;
           }
       });
    }
    //
    //
    if(phone == '' || !phone){
       $html.find('div').each(function (){
           let _div_text = $(this).text();
           if((_div_text.indexOf('tel') != -1 ||
               _div_text.indexOf('Hotline') != -1 ||
               _div_text.indexOf('fax') != -1 ||
               _div_text.indexOf('mobile') != -1 ||
               _div_text.indexOf('+86') != -1 ||
               _div_text.indexOf('0086') != -1 ||
               _div_text.indexOf('86-0755') != -1 ||
               _div_text.indexOf('0755')!=-1 ||
               _div_text.indexOf('whatsapp') != -1 ||
               _div_text.indexOf('phone') != -1 ||
               _div_text.indexOf('专线')!=-1) && (_div_text.indexOf('hotel') ==-1 ||
                    _div_text.indexOf('Intellectual') ==-1 ||
                    _div_text.indexOf('Patel') ==-1)
           ){
               phone = _div_text;
           }
       });
    }
     //
    if(phone == '' || !phone){
        phone = $html.find('.phone').text();
    }
    //排除一些
    if(phone){
        //去一些字符
        phone = phone.replace('https://api.whatsapp.com/send?phone=','');
        phone = phone.replace('{','');
        phone = phone.replace('}','');
        phone = phone.replace('Mobile：','');
        phone = phone.replace('Tel: ','');
        phone = phone.replace('手机：','');
        if(phone.indexOf('click')!=-1 || phone.indexOf('font-size')!=-1){
            phone = '';
        }
    }

    return phone;
}

function util_url_get_domain(url=''){
    url = url.replace('https://','');
    url = url.replace('http://','');
    url = url.replace('www.','');
    urlArr = url.split('/');
    if(urlArr.length>0){
        return urlArr[0];
    }
    return '';
}

function util_url_get_domain_host(url=''){
    domain = util_url_get_domain(url);
    if(domain){
        domainArr = domain.split('.');
        if(domainArr.length>1){
           var domain_may = domainArr[1];
           if(domain_may.length>=5){
               return domain_may;
           }else{
               return domainArr[0];
           }
        }else if(domainArr.length==1){
            return domainArr[0];
        }
    }
    return '';
}

function get_seller_id_from_url(seller_url=''){
    //https://www.amazon.com/gp/help/seller/at-a-glance.html/ref=dp_merchant_link?ie=UTF8&seller=A265O6I0NWO52E&asin=B088N7GSV5&ref_=dp_merchant_link&isAmazonFulfilled=1
    let seller_id = '';
    let seller_url_arr = seller_url.split('&');
    for (let i=0;i<seller_url_arr.length;i++){
        if(seller_url_arr[i].indexOf('seller=') !=-1){
            seller_id = seller_url_arr[i].replace('seller=','');
            break;
        }
    }
    return seller_id;
}

function plugin_set_expire(expire,callback){
    chrome.storage.local.set({expire: expire}, callback);
}

function plugin_get_expire(callback){
    chrome.storage.local.get('expire', callback);
}

function pause_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause: 0}, callback);
            }else{
                chrome.storage.local.set({pause: 1}, callback);
            }
        }
    });
}

function pause_page_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_page';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_page: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_page: 0}, callback);
            }else{
                chrome.storage.local.set({pause_page: 1}, callback);
            }
        }
    });
}

function pause_s_time(){
    chrome.storage.local.get(null, function(items) {
        //
        chrome.storage.local.set({pause_s_time: Date.now()});
    });
}

//
function ajax_get(url){
    console.log('url:'+url);
    let _html_result = '';
    var exhibitors_ajax = $.ajax({
             //url: 'https://www.google.com/maps/place/VIP+Wigs+%26+Prosthesis/@37.9009282,-122.0623831,17z/data=!3m1!4b1!4m6!3m5!1s0x808561953bedbbfd:0xe9365860131da46b!8m2!3d37.9009282!4d-122.0623831!16s%2Fg%2F1tcxpx4r?authuser=0&hl=en',
             url:url,
             data: {},
             type: 'GET',
             async:false,
             crossDomain: true,
             timeout:5000,//20 s
             dataType: 'html',
             contentType:'text/html; charset=utf-8',
             //dataType: 'json',
             //contentType:'application/json;charset=utf-8',
             success: function(data) {
                 _html_result = data;
             },
             error: function(xhr, textStatus, errorThrown) {
                _html_result = 'error';
            }
         });
    return _html_result;
}
//
function get_emails_filter(emails = []){
    var forbidden_keys = ['1.8.1','.cart', '.index', '.collection',
            '.js', 'template.404','tel:', 'mailto:', '.jpg', '.pdf', '.doc',
            '.xls', '.xlsx', '.png', '.jpeg', '.webp', '.gif', 'javascript:',
            'skype', '#', 'None', '.svg', 'desktop.ts', 'example', 'css', '.studio', 'image', 'jquery', 'swiper', 'myshopline.com',
            'img_', 'xxx.xxx', 'foundation-sites', 'exemple@mail.com', 'exemple@gmail.be', 'exemple@mail.ch', 'john@email.com',
            'your.email@address.com', 'stores@domain.com', 'test@email.com', 'first.last@company.com', 'you@email.com', 'your-email@shopify.com',
            'ada@ada.lt', 'johndoe@domain.com', 'your@email.com', 'jane.smith@email.com', 'abc@xyz.com', 'user@domain.com', 'template.account@template.blog',
            'john@test.com', 'emily@test.com', 'email@domain.com', 'yourname@email.com', 'jill@mail.com', 'joebloggs@email.com', 'abc@abc.abc', 'support@domain.com', 'yellow@hello.com'];
    var domain_emails = [];
    if(emails && emails.length>0){
        for(j=0;j<emails.length;j++){
            var current_email = emails[j];
            current_email = current_email.toLowerCase().trim();
            //把字符串最后一个.移除掉
            if(current_email[current_email.length-1] == '.'){
                current_email = current_email.slice(0,-1);
            }
            //排除有些如 .png
            var is_forbidden = false;
            for(k=0;k<forbidden_keys.length;k++){
                if(current_email.indexOf(forbidden_keys[k])!=-1){
                    is_forbidden = true;
                    break;
                }
            }
            //leaflet@1.8.0
            let current_email_arr = current_email.split('@');
            if(current_email_arr.length > 1){
                let current_a_houzhui = current_email_arr[1];
                let current_a_houzhui_arr = current_a_houzhui.split('.');
                let is_num_shuliang = 0;
                for(let k=0;k<current_a_houzhui_arr.length;k++){
                    if(util_isnumber(current_a_houzhui_arr[k])){
                        is_num_shuliang +=1;
                    }
                }
                if(is_num_shuliang >=2){
                    is_forbidden = true;
                }
            }
            //
            if(!is_forbidden && !domain_emails.includes(current_email)){
                domain_emails.push(current_email);
            }
            //
        }
    }
    return domain_emails;
}
//
function get_findemails_for_amazon(){
    return ["gmail.com", "yahoo.com", "hotmail.com", "aol.com", "msn.com","mac.com", "outlook.com","icloud.com", "comcast.net"];
}

function get_findemails_for_amazon_co_uk(){
    return ["hotmail.co.uk", "live.co.uk", "yahoo.co.uk", "aol.co.uk", "gmail.com", "yahoo.com", "hotmail.com", "aol.com", "msn.com", "outlook.com", "icloud.com"];
}

function get_findemails_for_amazon_co_jp(){
    return ["ne.jp", "outlook.jp", "yahoo.co.jp", "yahoo.ne.jp", "aol.jp", "hotmail.co.jp", "live.jp", "gmail.com", "yahoo.com", "hotmail.com", "aol.com", "msn.com", "outlook.com", "icloud.com"];
}

function get_findemails_for_amazon_de(){
    return ["gmx.de", "yahoo.de", "web.de", "hotmail.de", "aol.de", "t-online.de", "freenet.de", "outlook.de", "gmail.com", "hotmail.com", "yahoo.com", "aol.com", "msn.com", "outlook.com"];
}

function get_findemails_for_amazon_fr(){
    return ["yahoo.fr", "hotmail.fr", "outlook.fr", "live.fr", "free.fr", "gmail.com", "hotmail.com", "yahoo.com", "aol.com"];
}

function get_findemails_for_amazon_es(){
    return ["yahoo.es", "hotmail.es", "gmail.com", "hotmail.com"];
}

function get_findemails_for_amazon_ca(){
    return ["yahoo.ca", "hotmail.ca", "live.ca"];
}

function get_findemails_for_amazon_com_mx(){
    return ["gmail.com", "hotmail.com", "yahoo.com", "aol.com", "msn.com", "outlook.com"];
}

//
function storage_shangjia_item_url_set(_shangjia_info={},local_num=1, callback){
    //
    if(typeof _shangjia_info['shangjia_item_url'] == 'undefined'){
        return;
    }
    if(_shangjia_info['shangjia_item_url'].indexOf('undefined') != -1){
        return;
    }
    //
    let _shangjia_item_url = _shangjia_info['shangjia_item_url'];
    let _shangjia_item_url_arr = _shangjia_item_url.split('?');
    let prefix = 'shangjia_shangjia_item_url_'+$.md5(_shangjia_item_url_arr[0]);
    //
    chrome.storage.local.get(null, function(items) {
        let total_add_shangjia_num = 0;
        for(let key in items){
            if(key.indexOf('shangjia_shangjia_item_url_') != -1){
                total_add_shangjia_num += 1;
            }
        }
        total_add_shangjia_num = total_add_shangjia_num + local_num;
        //
        if(!items.hasOwnProperty(prefix)){
            //获取reivew链接
            let _review_request_urls = [];
            let asin = util_get_asin(_shangjia_item_url);
            let domain = util_url_get_domain(_shangjia_item_url);
            if(domain.indexOf('.com')!=-1){
                let emails_types = get_findemails_for_amazon();
                for(let i=0;i<emails_types.length;i++){
                    let _review_request_url = 'https://www.amazon.com/title/product-reviews/'+asin+'/ref=cm_cr_arp_d_viewopt_kywd?ie=UTF8&reviewerType=all_reviews&pageNumber=1&filterByKeyword='+emails_types[i];
                    _review_request_urls.push(_review_request_url);
                }
            }else if(domain.indexOf('.co.jp')!=-1){
                let emails_types = get_findemails_for_amazon_co_jp();
                for(let i=0;i<emails_types.length;i++){
                    let _review_request_url = 'https://www.amazon.co.jp/title/product-reviews/'+asin+'/ref=cm_cr_arp_d_viewopt_kywd?ie=UTF8&reviewerType=all_reviews&pageNumber=1&filterByKeyword='+emails_types[i];
                    _review_request_urls.push(_review_request_url);
                }
            }else if(domain.indexOf('.co.uk')!=-1){
                let emails_types = get_findemails_for_amazon_co_uk();
                for(let i=0;i<emails_types.length;i++){
                    let _review_request_url = 'https://www.amazon.co.uk/title/product-reviews/'+asin+'/ref=cm_cr_arp_d_viewopt_kywd?ie=UTF8&reviewerType=all_reviews&pageNumber=1&filterByKeyword='+emails_types[i];
                    _review_request_urls.push(_review_request_url);
                }
            }
            //
            let obj = {};
            obj[prefix] = {
                '_shangjia_item_url': _shangjia_info['shangjia_item_url'],
                '_is_request':0,
                '_review_request_urls':_review_request_urls,
                '_emails':[],
                //
                'num':(total_add_shangjia_num+1)
            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}
//
function request_shangjia_item_url_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        let _shangjia_item_url = need_item['_shangjia_item_url'];
        console.log('request_shangjia_item_url_ajax:'+_shangjia_item_url);
        let _shangjia_item_url_four_character = _shangjia_item_url.slice(0,4);
        if(_shangjia_item_url.indexOf('javascript')!=-1 || _shangjia_item_url_four_character !='http'){
            need_item['_seller_url_is_request'] = 2;
            need_item['_is_request'] = 1;
            let obj = {};
            obj[storage_key] = need_item;
            chrome.storage.local.set(obj, function (){
                //
                //
            });
            //
            return false;
        }
        //
        let _review_request_urls = need_item['_review_request_urls'];
        let _process_complete = true;
        let _emails = [];
        for(let i=0;i<_review_request_urls.length;i++){
            let _review_request_url = _review_request_urls[i];
            let _result_html = ajax_get(_review_request_url);
            if(_result_html && _result_html!='error'){
                //
                console.log('_review_request_url:'+_review_request_url);
                let domain = util_url_get_domain(_shangjia_item_url);
                //console.log(_result_html);
                let _dom = $(_result_html);
                _dom.find("#cm_cr-review_list div[data-hook='review']").each(function (){
                    //
                    let _review_item_url = $(this).find("a[data-hook='review-title']").attr('href');
                    if(domain.indexOf('.com')!=-1){
                        _review_item_url = 'https://www.amazon.com'+_review_item_url;
                    }else if(domain.indexOf('.co.jp')!=-1){
                        _review_item_url = 'https://www.amazon.co.jp'+_review_item_url;
                    }else if(domain.indexOf('.co.uk')!=-1){
                        _review_item_url = 'https://www.amazon.co.uk'+_review_item_url;
                    }
                    let _review_item_content = $(this).find("span[data-hook='review-body']").text();
                    console.log('_review_item_url:'+_review_item_url);
                    console.log('_review_item_content:'+_review_item_content);
                    //
                    let emails  = extractEmails(_review_item_content);
                    if(emails && emails.length>0){
                        _emails.push({
                            'email': emails[0],
                            '_review_item_url':_review_item_url
                        });
                    }
                    //
                });
                //
            }else{
                _process_complete = false;
            }
        }
        if(_process_complete){
            //
            need_item['_is_request'] = 2;
            need_item['_emails'] = _emails;
            //
            console.log('need_item');
            console.log(need_item);
            //
            let obj = {};
            obj[storage_key] = need_item;
            chrome.storage.local.set(obj, function (){
                    //
                    //
            });
        }
    })
}

function request_shangjia_item_url(){
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for(let key in items){
            if(key.indexOf('shangjia_shangjia_item_url_') != -1){
                if(items[key]['_is_request'] == 0 || (items[key]['_is_request'] == 1 && items[key]['_s_time'] < (Date.now()-8000))){
                    need_item = items[key];
                    need_item['_is_request'] = 1;
                    need_item['_s_time'] = Date.now();
                    let obj = {};
                    obj[key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        request_shangjia_item_url_ajax(key);
                        //
                    });
                    break;
                }
            }
        }
        //
    });
}
//

//
function request_shangjia_seller_link_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        let _seller_url = need_item['_seller_url'];
        console.log('request_shangjia_seller_link_ajax:'+_seller_url);
        let _seller_url_four_character = _seller_url.slice(0,4);
        if(_seller_url.indexOf('javascript')!=-1 || _seller_url_four_character!='http'){
            need_item['_seller_url_is_request'] = 2;
            let obj = {};
            obj[storage_key] = need_item;
            chrome.storage.local.set(obj, function (){
                //
                //
            });
            //
            return false;
        }
        //
        $.ajax({
            url:need_item['_seller_url'],
            timeout : 5000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:true,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
               var $html = $(data);
               //
                /*
                _seller_about
                _seller_detail
                 */
               need_item['_seller_about'] = $html.find('#spp-expander-about-seller').text();
               if(need_item['_seller_about']){
                    let _seller_detail = $html.find('#page-section-detail-seller-info').text();
                   _seller_detail = _seller_detail.replace('Detailed Seller InformationBusiness Name:','');
                   _seller_detail = _seller_detail.trim();
                   need_item['_seller_detail'] = _seller_detail;
                   need_item['_seller_country'] = $html.find('#page-section-detail-seller-info .a-row:last-child').text();
                   need_item['_seller_phone'] = $html.find('#seller-contact-phone').text();
                   need_item['_seller_url_is_request'] = 2;
               }else{
                   //查看是否是出现验证页了
                    let _g = $html.find('#g').attr('id');
                    if(_g && _g == 'g'){
                        need_item['_seller_url_is_request'] = 0;
                        pause_s_time();
                        sendPopTips("遇到反爬,请开启或者更换代理线路或者暂停采集，稍后再采集!", need_item['_shangjia_item_url']);
                    }else{
                        need_item['_seller_url_is_request'] = 2;
                    }
               }

               let obj = {};
               obj[storage_key] = need_item;
               chrome.storage.local.set(obj, function (){
               });

               //
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log( jqXHR, textStatus, errorThrown );
                //
                need_item['_seller_url_is_request'] = 0;
                if(errorThrown == 'Not Found' || jqXHR.status == '404'){
                    need_item['_seller_url_is_request'] = 2;
                }
                //
                need_item['_error'] = errorThrown;
                let obj = {};
                obj[storage_key] = need_item;
                chrome.storage.local.set(obj, function (){
                    //
                    //
                });
                if(jqXHR.status != '404'){
                    pause_s_time();
                    sendPopTips("遇到反爬,请开启或者更换代理线路或者暂停采集，稍后再采集!", need_item['_seller_url']);
                }
            }
        });
        //
    })
}

function request_shangjia_seller_link(){
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for(let key in items){
            if(key.indexOf('shangjia_shangjia_item_url_') != -1){
                if(items[key]['_is_request'] == 2 &&
                    (items[key]['_seller_url_is_request'] ==0 || (items[key]['_seller_url_is_request'] == 1 && items[key]['_seller_url_s_time'] < (Date.now()-8000))  )){
                    need_item = items[key];
                    need_item['_seller_url_is_request'] = 1;
                    need_item['_seller_url_s_time'] = Date.now();
                    let obj = {};
                    obj[key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        request_shangjia_seller_link_ajax(key);
                        //
                    });
                    break;
                }
            }
        }
        //
    });
}

function xintiao(){
    chrome.storage.local.get(null, function(items) {
         if(!items.hasOwnProperty('pause') || items['pause'] == 0){
             if(items.hasOwnProperty('pause_s_time')  && (items['pause_s_time']+5000) > Date.now()){
                 console.log('因出现人机验证，暂停一会');
             }else{
                 console.log('爬取中');
                 //request_shangjia_item_url();
                 //request_shangjia_seller_link();
             }
         }else{
             console.log('已暂停爬取');
         }
    });
    //
    chrome.storage.local.get(null, function(items) {
        console.log('items');
        console.log(items);
    });

}
xintiao();
setInterval(xintiao, 5000);

//
function storage_clear(){
    /*plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date != 'undefined'){
            chrome.storage.local.clear(function(){
                console.log('remove all');
                plugin_set_expire(expire_date);
            })
        }else{
            chrome.storage.local.clear(function(){
                console.log('remove all');
            })
        }
    });*/
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for (let key in items) {
            if (key.indexOf('shangjia_shangjia_item_url') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if (key.indexOf('shangjia_seller_id') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if(key == 'data_process'){
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
        }
    });
}
//
function get_data_process(){

    let total_add_shangjia_num = 0;
    let has_caiji_shangjia_num = 0;
    let email_num = 0;

    chrome.storage.local.get(null, function(items) {
        //
        for(let key in items){
            if(key.indexOf('shangjia_shangjia_item_url_') != -1){
                total_add_shangjia_num += 1;
                if(items[key]['_is_request'] == 2){
                    has_caiji_shangjia_num += 1;
                    //
                    let _emails = items[key]['_emails'];
                    email_num += _emails.length;
                    //
                }
            }
        }
        //
        let obj = {};
        obj['data_process'] = {
            'total_add_shangjia_num': total_add_shangjia_num,
            'has_caiji_shangjia_num': has_caiji_shangjia_num,
            'email_num': email_num
        }
        chrome.storage.local.set(obj, function (){
            //
            //
        });
        //
    });
}
//
function data_process_get(callback){
     /*chrome.storage.sync.get('domains', (res) => {
        console.log(res);
        return res;
     });*/
    chrome.storage.local.get('data_process', callback);
}

function storage_get(callback){
    chrome.storage.local.get(null, callback);
}

function amz_reviews_set(_shangjia_info={},local_num=1, callback){
    //
    //
    let _shangjia_item_url = _shangjia_info['_review_title_url'];
    let prefix = 'amz_review_'+$.md5(_shangjia_item_url);
    //
    chrome.storage.local.get(null, function(items) {
        let total_add_shangjia_num = 0;
        for(let key in items){
            if(key.indexOf('review_') != -1){
                total_add_shangjia_num += 1;
            }
        }
        total_add_shangjia_num = total_add_shangjia_num + local_num;
        //
        if(!items.hasOwnProperty(prefix)){
            //
            let obj = {};
            obj[prefix] = {
                '_profile_url':_shangjia_info['_profile_url'],
                '_profile_img':_shangjia_info['_profile_img'],
                '_profile_name':_shangjia_info['_profile_name'],

                '_review_title':_shangjia_info['_review_title'],
                '_review_title_url':_shangjia_info['_review_title_url'],
                '_review_star':_shangjia_info['_review_star'],
                '_review_date':_shangjia_info['_review_date'],
                '_review_product_attr':_shangjia_info['_review_product_attr'],
                '_review_verified_purchase':_shangjia_info['_review_verified_purchase'],
                '_review_body':_shangjia_info['_review_body'],
                '_review_imgs':_shangjia_info['_review_imgs'],
                //
                'num':(total_add_shangjia_num+1)
            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if(request.action == 'shangjia_item_url_update'){
        console.log('action',request,sender,sendResponse);
        //
        let shangjia_infos = request.shangjia_infos;
        //
        for (let i=0;i<shangjia_infos.length;i++){
            storage_shangjia_item_url_set(shangjia_infos[i], (i+1), function (){

           });
        }
        //
        //request {action: "send", keyword: "keyword value"}
        //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
        //sendResponse  ƒ () { [native code] }
        sendResponse({state:'关键词填写成功！'});
    }else if(request.action  == 'can_zidong_caiji'){
        console.log('can_zidong_caiji',request,sender,sendResponse);
        //判断，如果加入超过3000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
            if(!items.hasOwnProperty('pause_page') || items['pause_page'] == 0){
                //已开启
                let total_add_shangjia_num = 0;
                for(let key in items){
                    if(key.indexOf('shangjia_shangjia_item_url_') != -1){
                        total_add_shangjia_num += 1;
                    }
                }
                if(total_add_shangjia_num < 3000){
                    sendResponse(JSON.stringify({state:0}));
                }else{
                    sendResponse(JSON.stringify({state:1}));
                }
                //
            }else{
                //已关闭
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }else if(request.action  == 'can_caiji'){
        console.log('can_caiji',request,sender,sendResponse);
        //
        chrome.storage.local.get(null, function(items) {
            if(!items.hasOwnProperty('pause') || items['pause'] == 0){
                sendResponse(JSON.stringify({state:0}));
            }else{
                //已关闭
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }else if(request.action == 'amz_reviews_update'){
        //
        let reviews = request.reviews;
        //
        for (let i=0;i<reviews.length;i++){
            amz_reviews_set(reviews[i], (i+1), function (){

           });
        }
        //
        //request {action: "send", keyword: "keyword value"}
        //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
        //sendResponse  ƒ () { [native code] }
        sendResponse({state:'成功！'});
        return true;
        //
    }else if(request.action == 'amz_get_reviews'){
        //
        let amz_reviews = [];
        chrome.storage.local.get(null, function(items) {
            //
            for (let key in items) {
                if (key.indexOf('amz_review_') != -1) {
                    amz_reviews.push(items[key]);
                    chrome.storage.local.remove(key, function() {
                       console.log(`键名 ${key} 的值已被清空！`);
                    });
                }
            }
             //
            let amz_reviews_new_data = util_dictArraySorting(amz_reviews, 'num', 'asc');
            console.log('amz_reviews_new_data');
            console.log(amz_reviews_new_data);
            sendResponse(JSON.stringify({amz_reviews_new_data:amz_reviews_new_data}));
        });
        return true;
        //
    }
  }
);
function sendPopTips(msg = '', url=''){
     chrome.runtime.sendMessage({
        action: 'background-tips',
        info: msg,
         url:url,
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });
}

/**
 * 1.
 * chrome.runtime.onInstalled.addListener(details => {
  console.log('previousVersion', details.previousVersion);
});
2.
 //发送消息
 chrome.runtime.sendMessage({
        action: 'send',
        keyword: 'keyword value'
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'send') {
      console.log('action',request,sender,sendResponse);
//  request {action: "send", keyword: "keyword value"}
 //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
//sendResponse  ƒ () { [native code] }
      sendResponse({state:'关键词填写成功！'});
    }
  }
);
 */
