// 使用自定义函数解析查询字符串并返回参数对象
function util_getCurrentUrlQueryStringParams() {
    // 获取当前URL的查询字符串部分
    var queryString = window.location.search;
    var params = {};
    // 移除开头的问号
    queryString = queryString.substring(1);
    // 分割成键值对数组
    var keyValuePairs = queryString.split('&');
    // 遍历键值对数组，将每一对分割成键和值，并存入params对象
    keyValuePairs.forEach(function(keyValuePair) {
        var pair = keyValuePair.split('=');
        var key = decodeURIComponent(pair[0]);
        var value = decodeURIComponent(pair[1] || '');
        params[key] = value;
    });
    return params;
}

function util_url_get_domain(url=''){
    url = url.replace('https://','');
    url = url.replace('http://','');
    url = url.replace('www.','');
    urlArr = url.split('/');
    if(urlArr.length>0){
        return urlArr[0];
    }
    return '';
}

var navigation_url = '';
function perf_observer(list, obserer){
    //console.log('aa');
    //console.log(getNetworkRequests(list.getEntriesByType('resource')));
    performanceResourceList = list.getEntriesByType('resource');
    //console.log(performanceResourceList);
    for(i = 0; i<performanceResourceList.length; i++){
        performanceResourceItem = performanceResourceList[i];
        //console.log('abababa');
        //console.log(performanceResourceItem);
        if(performanceResourceItem['initiatorType'] == 'xmlhttprequest'){
            if(performanceResourceItem['name'].indexOf('s/query')!=-1){
                //console.log(performanceResourceItem['name']);
                console.log('bbbb'+performanceResourceItem['name']);
                setTimeout(function (){
                    extract_shangjias();
                },1000);
            }
        }
    }
    //////
    /*performanceNavigationList = list.getEntriesByType('navigation');
    for(i = 0; i<performanceNavigationList.length; i++) {
        performanceNavigationItem = performanceNavigationList[i];
        if (performanceNavigationItem['initiatorType'] == 'navigation') {
            navigation_url = performanceNavigationItem['name']
        }
    }*/
}
var observer_ = new PerformanceObserver(perf_observer);
//observer_.observe({entryTypes:['resource', 'navigation']});
//observer_.observe({entryTypes:['resource', 'navigation', 'paint']});
$(document).ready(function () {
    let current_url = window.location.href;
    setTimeout(function (){
        amz_add_download_btn();
    },2000);
});

function exportToExcel(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".xlsx");
}

//send message to pop
function send_message_to_popup(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}

//send message to pop
function send_message_to_background(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}

//
function downloadIamge(imgsrc, name){//下载图片地址和图片名
    let image = new Image();
    // 解决跨域 Canvas 污染问题
    image.setAttribute("crossOrigin", "anonymous");
    image.onload = function() {
        let canvas = document.createElement("canvas");
        canvas.width = image.width;
        canvas.height = image.height;
        let context = canvas.getContext("2d");
        context.drawImage(image, 0, 0, image.width, image.height);
        let url = canvas.toDataURL("image/jpeg"); //得到图片的base64编码数据
        let a = document.createElement("a"); // 生成一个a元素
        let event = new MouseEvent("click"); // 创建一个单击事件
        a.download = name || "photo"; // 设置图片名称
        a.href = url; // 将生成的URL设置为a.href属性
        a.dispatchEvent(event); // 触发a的单击事件
    }
    image.src = imgsrc;
}

function util_amz_get_asin(url = ''){
    let url_arr = url.split('dp/');
    if(url_arr.length>=2){
        let url_dp_str = url_arr[1];
        let url_dp_arr = url_dp_str.split('/');
        let dp =  url_dp_arr[0];
        if(dp.length>=6){
            return dp;
        }
    }
    return '';
}

function util_amz_getscript_pageData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('ImageBlockATF') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}
//
function amz_product_lunbo_imgs_download(){
   let _leftColHtml =  $('#leftCol').html();
   let _amz_script = util_amz_getscript_pageData_content(_leftColHtml);
   //console.log('_amz_script');
   //console.log(_amz_script);
   let _amz_script_tmp_arr = _amz_script.split("var data =");
   let _amz_script_tmp_str = _amz_script_tmp_arr[1];
   let _amz_script_tmp_str_arr = _amz_script_tmp_str.split('A.trigger');
   let _amz_script_imgs_str = _amz_script_tmp_str_arr[0];
   _amz_script_imgs_str = _amz_script_imgs_str.trim();
   _amz_script_imgs_str = _amz_script_imgs_str.slice(0,-1);
   //
    let _amz_script_imgs_tmp_arr  = _amz_script_imgs_str.split("'colorImages':");
    //
    let _amz_script_imgs_temp2 = _amz_script_imgs_tmp_arr[1];
    let _amz_script_imgs_temp2_str = _amz_script_imgs_temp2.split("'colorToAsin'");
    let _amz_script_imgs = _amz_script_imgs_temp2_str[0];
    _amz_script_imgs = _amz_script_imgs.trim();
    _amz_script_imgs = _amz_script_imgs.slice(0,-1);
    _amz_script_imgs = _amz_script_imgs.replace("{ 'initial':","");
    _amz_script_imgs = _amz_script_imgs.slice(0,-1);
    let _amz_script_imgs_arr = JSON.parse(_amz_script_imgs);
    console.log('_amz_script_imgs_arr');
    console.log(_amz_script_imgs_arr);
    //
    let current_url = window.location.href;
    let asin = util_amz_get_asin(current_url);
    let _sort = 1;
    for(let i=0;i<_amz_script_imgs_arr.length;i++){
        let _img = _amz_script_imgs_arr[i]['hiRes'];
        let _img_src = _img;
        let _imgarr = _img.split('/');
        let _img_name = _imgarr[_imgarr.length-1];
        let _img_name_arr = _img_name.split('.');
        _img_name = _img_name_arr[0];
        _img_name = 'amazon_'+asin+'_'+_sort+'_'+_img_name;
        //
        downloadIamge(_img_src,_img_name);
        _sort++;
    }
    //
}

function amz_product_detail_imgs_download(){
    let current_url = window.location.href;
    let asin = util_amz_get_asin(current_url);
    let _sort = 1;
    $('#aplus_feature_div img').each(function (){
        let _img = $(this).attr('data-src');
        let _img_src = _img;
        let _imgarr = _img.split('/');
        let _img_name = _imgarr[_imgarr.length-1];
        let _img_name_arr = _img_name.split('.');
        _img_name = _img_name_arr[0];
        _img_name = 'amazon_'+asin+'_'+_sort+'_detail_'+_img_name;
        //
        downloadIamge(_img_src,_img_name);
        _sort++;
    });
}

function amz_add_download_btn(){
    let current_url = window.location.href;
    if(current_url.indexOf('dp/')!=-1){
        var btn_product_lunbo_imgs = $("<button>", {
            text: '下载轮播主图', // 按钮文本
            style: "display: block;\n" +
                "    top: 460px;\n" +
                "    right: 0;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    border: 0;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    border-radius: 22px;",
            click: function() {
               amz_product_lunbo_imgs_download();
            }
        });
        $('#leftCol').append(btn_product_lunbo_imgs);
        //
        var btn_product_details_imgs = $("<button>", {
            text: '下载描述图片', // 按钮文本
            style: "display: block;\n" +
                "    top: 530px;\n" +
                "    right: 0;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    border: 0;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    margin-top: 10px;\n" +
                "    border-radius: 22px;",
            click: function() {
               amz_product_detail_imgs_download();
            }
        });
        $('#leftCol').append(btn_product_details_imgs);
        //
    }
}